/**
 * ai.jsx MaratShagiev m_js@bk.ru 13.07.2015
 */


//@target illustrator
//@targetengine "session"

(function () {

  if ( typeof JSON !== 'object' ) {
    JSON = {};
  }
  JSON_LIB ();

  var w = makePalette ();
  w.show ();

  function makePalette () {

    var opts = getOpts ();

    // The script can work in several parallel running versions of Illustrator
    var targ          = "illustrator-" + (app.version).slice ( 0, 2 ),
        scaleAboutArr = [ 'Center', 'Top', 'Bottom', 'Left', 'Right',
                          'Top-Left', 'Top-Right', 'Bottom-Left', 'Bottom-Right',
                          'Document Origin' ];

    /**
     * PALETTE STRUCTURE
     * */
    var w                = new Window ( 'palette', 'Resize Each v1.0' ),
        gr_opts          = w.add ( 'group' ),
        gr_opts_exact    = gr_opts.add ( 'group' ),
        gr_opts_exact_ch = gr_opts_exact.add ( 'group' );

    w.gr_opts_exactIn = gr_opts_exact.add ( 'group' );

    var gr_opts_scale      = gr_opts.add ( 'group', undefined, 'options' ),
        gr_opts_scaleAbout = gr_opts.add ( 'group' ),
        gr_btns            = w.add ( 'group' );

    /**
     * MARGINS, SPACING AND ORIENTATION
     * */
    w.ch_exact = gr_opts_exact_ch.add ( 'checkbox', undefined, 'Exact size:' );
    w.gr_opts_exactIn.add ( 'statictext', undefined, 'width:' );
    w.txt_inputW = w.gr_opts_exactIn.add ( "edittext", [ 0, 0, 57, 25 ], "", { multiline: false, scrolling: false } );
    w.gr_opts_exactIn.add ( 'statictext', undefined, 'height:' );
    w.txt_inputH = w.gr_opts_exactIn.add ( "edittext", [ 0, 0, 57, 25 ], "", { multiline: false, scrolling: false } );

    w.ch_uniform = gr_opts_scale.add ( 'checkbox', undefined, 'Uniform' );
    w.ch_changeFillPatt = gr_opts_scale.add ( 'checkbox', undefined, 'Scale fill pattern' );
    w.ch_changeStrokePatt = gr_opts_scale.add ( 'checkbox', undefined, 'Scale stroke pattern' );
    w.ch_changeStroke = gr_opts_scale.add ( 'checkbox', undefined, 'Scale stroke' );

    gr_opts_scaleAbout.add ( 'statictext', undefined, 'Scale about: ' );
    w.drop_scaleAbout = gr_opts_scaleAbout.add ( 'dropdownlist', undefined, scaleAboutArr );

    w.btn_toWidth = gr_btns.add ( 'button', [ 0, 0, 60, 25 ], 'to width' );
    w.btn_toHieght = gr_btns.add ( 'button', [ 0, 0, 66, 25 ], 'to height' );
    w.btn_toExact = gr_btns.add ( 'button', [ 0, 0, 60, 25 ], 'exact' );

    /**
     * MARGINS, SPACING AND ORIENTATION
     * */
    gr_opts.orientation = 'column';
    gr_opts_scale.orientation = 'column';

    gr_opts_exact.alignChildren = 'left';
    gr_opts.alignChildren = 'left';
    gr_opts_exact.orientation = 'column';

    gr_opts_scale.alignment = 'left';
    gr_opts_scale.alignChildren = 'left';

    /**
     * HENDLERS
     * */
    w.btn_toWidth.onClick = function () {
      var bt = new BridgeTalk ();
      bt.target = targ;

      var opts = JSON.stringify ( _getPanValues ( "w" ) );

      bt.body =
        focusToFile.toString () + ";" +
        parseJsonStr.toString () + ";" +
        resizeByObj.toString () + ";" +
        setStroke.toString () +
        ";resizeByObj('" + opts + "');focusToFile();";

      bt.send ();
    }

    w.btn_toHieght.onClick = function () {
      var bt = new BridgeTalk ();
      bt.target = targ;

      var opts = JSON.stringify ( _getPanValues ( 'h' ) );

      bt.body =
        focusToFile.toString () + ";" +
        parseJsonStr.toString () + ";" +
        resizeByObj.toString () + ";" +
        setStroke.toString () +
        ";resizeByObj('" + opts + "');focusToFile();";

      bt.send ();
    }

    w.btn_toExact.onClick = function () {
      var bt = new BridgeTalk ();
      bt.target = targ;

      var opts = JSON.stringify ( _getPanValues ( 'b' ) );

      bt.body =
        focusToFile.toString () + ";" +
        parseJsonStr.toString () + ";" +
        resizeByObj.toString () + ";" +
        setStroke.toString () +
        ";resizeByObj('" + opts + "');focusToFile();";

      bt.send ();
    }

    w.ch_exact.onClick = function () {
      if ( w.ch_exact.value == true ) {
        w.gr_opts_exactIn.enabled = true;
        w.btn_toExact.enabled = true;
        w.btn_toHieght.enabled = w.btn_toWidth.enabled = false;
      } else {
        w.gr_opts_exactIn.enabled = false;
        w.btn_toHieght.enabled = w.btn_toWidth.enabled = true;
        w.btn_toExact.enabled = false;
        w.txt_inputW.text = w.txt_inputH.text = '';
      }
    }

    w.txt_inputW.onActivate = function () {
      if ( w.ch_uniform.value == true ) {
        w.txt_inputH.text = '';
      }
    }

    w.txt_inputH.onActivate = function () {
      if ( w.ch_uniform.value == true ) {
        w.txt_inputW.text = '';
      }
    }

    w.txt_inputH.addEventListener ( 'changing', function ( e ) {
      var re = /[^\d\.,]/gmi; // only digits, dots and comma
      var re2 = /[,]/gmi; // comma by dot
      var re3 = /[\.]{2,}/gmi; // two or more dots by one
      w.txt_inputH.text = (w.txt_inputH.text).replace ( re, '' );
      w.txt_inputH.text = (w.txt_inputH.text).replace ( re2, '.' );
      w.txt_inputH.text = (w.txt_inputH.text).replace ( re3, '.' );
    } )

    w.txt_inputW.addEventListener ( 'changing', function ( e ) {
      var re = /[^\d\.,]/gmi; // only digits, dots and comma
      var re2 = /[,]/gmi; // comma by dot
      var re3 = /[\.]{2,}/gmi; // two or more dots by one
      w.txt_inputW.text = (w.txt_inputW.text).replace ( re, '' );
      w.txt_inputW.text = (w.txt_inputW.text).replace ( re2, '.' );
      w.txt_inputW.text = (w.txt_inputW.text).replace ( re3, '.' );
    } )

    w.ch_uniform.onClick = function () {
      if ( w.ch_uniform.value == true ) {
        if ( w.txt_inputW.text != '' ) {
          w.txt_inputH.text = '';
        }
      }
    }

    w.onClose = function () {
      writeIni ( JSON.stringify ( _getPanValues ( '' ) ) );
      var bt = new BridgeTalk ();
      bt.target = targ;
      bt.body = focusToFile.toString () + ";focusToFile();";
      bt.send ();
    }

    /******************
     * PALETTE LIBRARY
     * ***************/
    function _getPanValues ( side ) {
      return {
        side:                    side,
        scaleAbout:              indexOf ( scaleAboutArr, w.drop_scaleAbout.selection.text ),
        changeFillPatt:          w.ch_changeFillPatt.value,
        changeStrokePatt:        w.ch_changeStrokePatt.value,
        changeStroke:            w.ch_changeStroke.value,
        uniform:                 w.ch_uniform.value,
        exact:                   w.ch_exact.value,
        inputW:                  w.txt_inputW.text,
        inputH:                  w.txt_inputH.text,
        winLeft:                 w.location[ 0 ],
        winTop:                  w.location[ 1 ],
        btn_toWidth_enabled:     w.btn_toWidth.enabled,
        btn_toHeight_enabled:    w.btn_toHieght.enabled,
        btn_toExact_enabled:     w.btn_toExact.enabled,
        gr_opts_exactIn_enabled: w.gr_opts_exactIn.enabled
      };
    }

    setOpts ( opts, w );

    return w;
  }

  function resizeByObj ( jsonString ) {

    var i,
        selWidth,
        selHeight,
        scaleFactorX,
        scaleFactorY,
        tmplWidth,
        tmplHeight,
        PT_TO_MM        = 2.834645668,
        scaleAboutArr   = [ 'Center', 'Top', 'Bottom', 'Left', 'Right',
                            'Top-Left', 'Top-Right', 'Bottom-Left', 'Bottom-Right',
                            'Document Origin' ],
        scaleAboutValue = '';

    var o = parseJsonStr ( jsonString );
    scaleAboutValue = (scaleAboutArr[ o.scaleAbout ]).replace ( /[- ]/g, '' ).toUpperCase ();

    if ( o.exact == true ) {
      (o.inputW == '' || o.inputW == 0) ? tmplWidth = +o.inputW : tmplWidth = parseFloat ( o.inputW );
      (o.inputH == '' || o.inputH == 0) ? tmplHeight = +o.inputH : tmplHeight = parseFloat ( o.inputH );

      if ( tmplWidth == 0 && tmplHeight > 0 && o.uniform == true ) {
        o.side = 'h';
      } else if ( tmplWidth > 0 && tmplHeight == 0 && o.uniform == true ) {
        o.side = 'w';
      } else if ( tmplWidth > 0 && tmplHeight > 0 && o.uniform == false ) {
        o.side = 'b';
      }
      i = 0;
    } else {
      tmplWidth = selection[ 0 ].width;
      tmplHeight = selection[ 0 ].height;

      i = 1;
    }

    for ( var j = i; j < selection.length; j++ ) {
      selWidth = selection[ j ].width;
      selHeight = selection[ j ].height;

      if ( o.side == 'w' ) {

        if ( o.exact == true ) {
          scaleFactorX = tmplWidth * PT_TO_MM * 100 / selWidth;
        } else {
          scaleFactorX = tmplWidth * 100 / selWidth;
        }
        if ( o.uniform == false ) {
          scaleFactorY = 100;
        } else {
          scaleFactorY = scaleFactorX;
        }
        selection[ j ].resize (
          scaleFactorX, scaleFactorY, true,
          o.changeFillPatt, o.changeFillGrad, o.changeStrokePatt,
          undefined, Transformation[ scaleAboutValue ]
        );
      } else if ( o.side == 'h' ) {
        if ( o.exact == true ) {
          scaleFactorY = tmplHeight * PT_TO_MM * 100 / selHeight;
        } else {
          scaleFactorY = tmplHeight * 100 / selHeight;
        }
        if ( o.uniform == false ) {
          scaleFactorX = 100;
        } else {
          scaleFactorX = scaleFactorY;
        }
        selection[ j ].resize (
          scaleFactorX, scaleFactorY, true,
          o.changeFillPatt, o.changeFillGrad, o.changeStrokePatt,
          undefined, Transformation[ scaleAboutValue ]
        );
      } else if ( o.side == 'b' ) {
        if ( tmplHeight != 0 && tmplWidth != 0 ) {
          scaleFactorX = tmplWidth * PT_TO_MM * 100 / selWidth;
          scaleFactorY = tmplHeight * PT_TO_MM * 100 / selHeight;
        } else if (tmplWidth == 0) {
          scaleFactorY = tmplHeight * PT_TO_MM * 100 / selHeight;
          scaleFactorX = 100;
        }  else if ( tmplHeight == 0 ) {
          scaleFactorX = tmplWidth * PT_TO_MM * 100 / selWidth;
          scaleFactorY = 100;
        }

        selection[ j ].resize (
          scaleFactorX, scaleFactorY, true,
          o.changeFillPatt, o.changeFillGrad, o.changeStrokePatt,
          undefined, Transformation[ scaleAboutValue ]
        );
      }
    }

    if ( o.changeStroke == true ) {
      for ( var k = i; k < selection.length; k++ ) {
        var scaleFactor_copy = scaleFactorX / 100;
        setStroke ( selection[ k ], scaleFactor_copy );
      }
    }
  }

  /**
   * ATTENSION!
   * DON'T MOVE LIBRARY FROM THIS PLACE 
   * BETWEEN FUNCTIONS resizeByObj() and setStroke()
   * I don't know why, but it only works so and not otherwise
   * */
  /**
   * creates a global JSON object containing two methods:
   * JSON.stringify(value, replacer, space) and JSON.parse(text, reviver)
   * */
  function JSON_LIB () {

    var rx_one       = /^[\],:{}\s]*$/,
        rx_two       = /\\(?:["\\\/bfnrt]|u[0-9a-fA-F]{4})/g,
        rx_three     = /"[^"\\\n\r]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g,
        rx_four      = /(?:^|:|,)(?:\s*\[)+/g,
        rx_escapable = /[\\"\u0000-\u001f\u007f-\u009f\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,
        rx_dangerous = /[\u0000\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g;

    function f ( n ) {
      return n < 10
        ? '0' + n
        : n;
    }

    function this_value () {
      return this.valueOf ();
    }

    if ( typeof Date.prototype.toJSON !== 'function' ) {

      Date.prototype.toJSON = function () {

        return isFinite ( this.valueOf () )
          ? this.getUTCFullYear () + '-' +
               f ( this.getUTCMonth () + 1 ) + '-' +
               f ( this.getUTCDate () ) + 'T' +
               f ( this.getUTCHours () ) + ':' +
               f ( this.getUTCMinutes () ) + ':' +
               f ( this.getUTCSeconds () ) + 'Z'
          : null;
      };

      Boolean.prototype.toJSON = this_value;
      Number.prototype.toJSON = this_value;
      String.prototype.toJSON = this_value;
    }

    var gap,
        indent,
        meta,
        rep;

    function quote ( string ) {

      rx_escapable.lastIndex = 0;
      return rx_escapable.test ( string )
        ? '"' + string.replace ( rx_escapable, function ( a ) {
        var c = meta[ a ];
        return typeof c === 'string'
          ? c
          : '\\u' + ('0000' + a.charCodeAt ( 0 ).toString ( 16 )).slice ( -4 );
      } ) + '"'
        : '"' + string + '"';
    }

    function str ( key, holder ) {

      var i,          // The loop counter.
          k,          // The member key.
          v,          // The member value.
          length,
          mind  = gap,
          partial,
          value = holder[ key ];

      if ( value && typeof value === 'object' &&
        typeof value.toJSON === 'function' ) {
        value = value.toJSON ( key );
      }

      if ( typeof rep === 'function' ) {
        value = rep.call ( holder, key, value );
      }

      switch ( typeof value ) {
        case 'string':
          return quote ( value );

        case 'number':

          return isFinite ( value )
            ? String ( value )
            : 'null';

        case 'boolean':
        case 'null':

          return String ( value );

        case 'object':

          if ( !value ) {
            return 'null';
          }

          gap += indent;
          partial = [];

          if ( Object.prototype.toString.apply ( value ) === '[object Array]' ) {

            length = value.length;
            for ( i = 0; i < length; i += 1 ) {
              partial[ i ] = str ( i, value ) || 'null';
            }

            v = partial.length === 0
              ? '[]'
              : gap
                  ? '[\n' + gap + partial.join ( ',\n' + gap ) + '\n' + mind + ']'
                  : '[' + partial.join ( ',' ) + ']';
            gap = mind;
            return v;
          }

          if ( rep && typeof rep === 'object' ) {
            length = rep.length;
            for ( i = 0; i < length; i += 1 ) {
              if ( typeof rep[ i ] === 'string' ) {
                k = rep[ i ];
                v = str ( k, value );
                if ( v ) {
                  partial.push ( quote ( k ) + (
                                   gap
                                     ? ': '
                                     : ':'
                                 ) + v );
                }
              }
            }
          } else {

            for ( k in value ) {
              if ( Object.prototype.hasOwnProperty.call ( value, k ) ) {
                v = str ( k, value );
                if ( v ) {
                  partial.push ( quote ( k ) + (
                                   gap
                                     ? ': '
                                     : ':'
                                 ) + v );
                }
              }
            }
          }

          v = partial.length === 0
            ? '{}'
            : gap
                ? '{\n' + gap + partial.join ( ',\n' + gap ) + '\n' + mind + '}'
                : '{' + partial.join ( ',' ) + '}';
          gap = mind;
          return v;
      }
    }

    if ( typeof JSON.stringify !== 'function' ) {
      meta = {    // table of character substitutions
        '\b': '\\b',
        '\t': '\\t',
        '\n': '\\n',
        '\f': '\\f',
        '\r': '\\r',
        '"':  '\\"',
        '\\': '\\\\'
      };
      JSON.stringify = function ( value, replacer, space ) {

        var i;
        gap = '';
        indent = '';

        if ( typeof space === 'number' ) {
          for ( i = 0; i < space; i += 1 ) {
            indent += ' ';
          }

        } else if ( typeof space === 'string' ) {
          indent = space;
        }

        rep = replacer;
        if ( replacer && typeof replacer !== 'function' &&
          (typeof replacer !== 'object' ||
          typeof replacer.length !== 'number') ) {
          throw new Error ( 'JSON.stringify' );
        }

        return str ( '', { '': value } );
      };
    }

    if ( typeof JSON.parse !== 'function' ) {
      JSON.parse = function ( text, reviver ) {

        var j;

        function walk ( holder, key ) {

          var k, v, value = holder[ key ];
          if ( value && typeof value === 'object' ) {
            for ( k in value ) {
              if ( Object.prototype.hasOwnProperty.call ( value, k ) ) {
                v = walk ( value, k );
                if ( v !== undefined ) {
                  value[ k ] = v;
                } else {
                  delete value[ k ];
                }
              }
            }
          }
          return reviver.call ( holder, key, value );
        }

        text = String ( text );
        rx_dangerous.lastIndex = 0;
        if ( rx_dangerous.test ( text ) ) {
          text = text.replace ( rx_dangerous, function ( a ) {
            return '\\u' +
              ('0000' + a.charCodeAt ( 0 ).toString ( 16 )).slice ( -4 );
          } );
        }

        if (
          rx_one.test (
            text
              .replace ( rx_two, '@' )
              .replace ( rx_three, ']' )
              .replace ( rx_four, '' )
          )
        ) {

          j = eval ( '(' + text + ')' );

          return typeof reviver === 'function'
            ? walk ( { '': j }, '' )
            : j;
        }

        throw new SyntaxError ( 'JSON.parse' );
      };
    }

  }

  /**
   * scaling stroke width of each items of class PageItem
   *
   * @param {Object} elem, items of class PageItem
   * @param {Number} scaleFactor, decimal float value, where 1.00 means a 100%
   */
  function setStroke ( elem, scaleFactor ) {

    try {
      switch ( elem.typename ) {

        case 'GroupItem' :
          for ( var j = 0; j < elem.pageItems.length; j++ ) {
            setStroke ( elem.pageItems[ j ], scaleFactor );
          }
          break;

        case 'PathItem':
          if ( elem.stroked ) {
            elem.strokeWidth *= scaleFactor;
          }
          break;

        case 'CompoundPathItem':
          if ( elem.pathItems[ 0 ].stroked ) {
            elem.pathItems[ 0 ].strokeWidth *= scaleFactor;
          }
          break;

        case 'TextFrame':
          var frameChars = elem.textRange;
          if ( frameChars.characterAttributes.strokeColor != '[NoColor]' ) {
            frameChars.characterAttributes.strokeWeight *= scaleFactor;
          }
          break;

        default:
          break;
      }
    } catch ( e ) {}
  }

  /**
   * return focus from the panel to the document
   * */
  function focusToFile () {
    illustrator.reveal ( new File ( activeDocument.fullName ) );
  }

  function writeIni ( opts ) {
//    var iniName = (($.fileName).slice ( ($.fileName).lastIndexOf ( '\\' ) + 1, -4 )) + '.ini';
    var iniName = 'resizeEach_v1.0.ini';
    var iniPath = Folder.userData + '/LocaleStore/';

    // !!! to evoid overlapping data easier remove the file and re-create with new data !!!
    if ( (new File ( iniPath + iniName ).exists) ) {
      (new File ( iniPath + iniName )).remove ();
    }

    var iniFolder = new Folder ( iniPath );

    if ( !iniFolder.exists ) {
      iniFolder.create ();
    }

    var ini = new File ( iniPath + iniName );

    ini.open ( 'e' );

    ini.writeln ( opts );
    ini.close ();

    return ini;
  }

  function readIni () {
//    var iniName = (($.fileName).slice ( ($.fileName).lastIndexOf ( '\\' ) + 1, -4 )) + '.ini';
    var iniName = 'resizeEach_v1.0.ini';
    var iniPath = Folder.userData + '/LocaleStore/';
    var ini = new File ( iniPath + iniName );

    if ( ini.exists ) {
      ini.open ( 'r' );
      var str = ini.readln ();
      ini.close ();
      return str;
    }
    return false;
  }

  // native JSON parser from JSON_LIB() why something is not working
  function parseJsonStr ( jsonString ) {
    var o = {};
    var arr = (jsonString.slice ( 1, -1 )).split ( ',' );
    var tmpArr;

    for ( i = 0; i < arr.length; i++ ) {
      tmpArr = arr[ i ].split ( ':' );
      tmpArr[ 0 ] = tmpArr[ 0 ].slice ( 1, -1 );

      if ( tmpArr[ 1 ] == 'true' ) {
        tmpArr[ 1 ] = true;
      } else if ( tmpArr[ 1 ] == 'false' ) {
        tmpArr[ 1 ] = false;
      } else if ( _isNum ( tmpArr[ 1 ] ) ) {
        tmpArr[ 1 ] = +tmpArr[ 1 ];
      } else {
        tmpArr[ 1 ] = tmpArr[ 1 ].slice ( 1, -1 );
      }
      o[ tmpArr[ 0 ] ] = tmpArr[ 1 ];
    }
    return o;
    function _isNum ( n ) {
      return !isNaN ( parseFloat ( n ) ) && isFinite ( n );
    }
  }

  function getOpts () {
    var ini = readIni ();
    if ( ini ) {
      return parseJsonStr ( ini );
    } else {
      return {
        side:                    '',
        scaleAbout:              0,
        changeFillPatt:          true,
        changeStrokePatt:        true,
        changeStroke:            true,
        uniform:                 true,
        exact:                   false,
        inputW:                  '',
        inputH:                  '',
        btn_toWidth_enabled:     true,
        btn_toHeight_enabled:    true,
        btn_toExact_enabled:     false,
        gr_opts_exactIn_enabled: false
      }
    }
  }

  function setOpts ( o, pan ) {

    if ( o.winLeft && o.winTop ) {
      pan.location = [ o.winLeft, o.winTop ];
    }
    pan.drop_scaleAbout.selection = o.scaleAbout;
    pan.ch_changeFillPatt.value = o.changeFillPatt;
    pan.ch_changeStrokePatt.value = o.changeStrokePatt;
    pan.ch_changeStroke.value = o.changeStroke;
    pan.ch_uniform.value = o.uniform;
    pan.ch_exact.value = o.exact;
    pan.txt_inputW.text = o.inputW;
    pan.txt_inputH.text = o.inputH;
    pan.gr_opts_exactIn.enabled = o.gr_opts_exactIn_enabled;
    pan.btn_toWidth.enabled = o.btn_toWidth_enabled;
    pan.btn_toHieght.enabled = o.btn_toHeight_enabled;
    pan.btn_toExact.enabled = o.btn_toExact_enabled;
  }

  function indexOf ( arr, str ) {

    for ( var i = 0; i < arr.length; i++ ) {
      if ( arr[ i ] === str ) return i;
    }
    return -1;
  }

} ());
